"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeJestConfig = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _through = require("through2");

var _through2 = _interopRequireDefault(_through);

var _gulpJest = require("gulp-jest");

var _gulpJest2 = _interopRequireDefault(_gulpJest);

var _jestJspm = require("jest-jspm");

var _jestJspm2 = _interopRequireDefault(_jestJspm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const makeJestConfig = (basePath, options) => (0, _jestJspm2.default)(basePath, options);

/**
 *
 * @param options
 *          @param options.jestConfig - config object or string path to config json file (default: {})
 *          @param options.jestOptions - config object for the Jest CLI (default: undefined)
 *          @param options.systemJs - where is system js located (default: "./jspm_packages/system")
 *          @param options.sjsConfigFile - where is the System JS config file located (default: "./config")
 *          @param options.loadSjsConfFile - whether to load the System JS config file (default: true)
 *          @param options.jspmPackages - location of jspm packages (default: "./jspm_packages")
 *          @param options.nodeModules - location of node modules dir (default: "./node_modules")
 *          @param options.displayWarnings - whether the plugin will output warnings to console (default: false)
 */

exports.default = options => {
  const myStream = _through2.default.obj((file, enc, cb) => {

    myStream.pipe((0, _gulpJest2.default)(_extends({}, options.jestOptions, {
      config: makeJestConfig(file.cwd, options)
    }))); //run jest through the gulp-jest plugin

    cb(null, file);
  });

  return myStream;
};

exports.makeJestConfig = makeJestConfig;